﻿using SecuritySystemContracts.BindingModels;
using SecuritySystemContracts.SearchModels;
using SecuritySystemContracts.ViewModels;
using SecuritySystemDataModels.Models;

namespace SecuritySystemContracts.StoragesContracts
{
    public interface IShopStorage
    {
        ShopViewModel? GetElement(ShopSearchModel model);
        List<ShopViewModel> GetFullList();
        List<ShopViewModel> GetFilteredList(ShopSearchModel model);
        ShopViewModel? Insert(ShopBindingModel model);
        ShopViewModel? Update(ShopBindingModel model);
        ShopViewModel? Delete(ShopBindingModel model);
        bool SellSecures(ISecureModel secureModel, int securesCount);
        bool CanSellSecures(ISecureModel secureModel, int securesCount);
    }
}
